Index: palm/trunk/SOURCE/land_surface_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 2693)
+++ palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 2696)
@@ -2494,76 +2628,1348 @@
           surf_lsm_v(l)%r_soil_min    = min_soil_resistance
        ENDDO
-
+!
+!--    Level 2, initialization of soil parameters via soil_type read from file.
+!--    Soil parameters are initialized for each (y,x)-grid point 
+!--    individually using default paramter settings according to the given
+!--    soil type.
+       IF ( soil_type_f%from_file )  THEN
+!
+!--       Level of detail = 1, i.e. a homogeneous soil distribution along the 
+!--       vertical dimension is assumed.
+          IF ( soil_type_f%lod == 1 )  THEN
+!
+!--          Horizontal surfaces
+             DO  m = 1, surf_lsm_h%ns
+                i = surf_lsm_h%i(m)
+                j = surf_lsm_h%j(m)
+             
+                st = soil_type_f%var_2d(j,i)
+                IF ( st /= soil_type_f%fill )  THEN
+                   surf_lsm_h%alpha_vg(:,m)    = soil_pars(0,st)
+                   surf_lsm_h%l_vg(:,m)        = soil_pars(1,st)
+                   surf_lsm_h%n_vg(:,m)        = soil_pars(2,st)
+                   surf_lsm_h%gamma_w_sat(:,m) = soil_pars(3,st)
+                   surf_lsm_h%m_sat(:,m)       = soil_pars(4,st)
+                   surf_lsm_h%m_fc(:,m)        = soil_pars(5,st)
+                   surf_lsm_h%m_wilt(:,m)      = soil_pars(6,st)
+                   surf_lsm_h%m_res(:,m)       = soil_pars(7,st)
+                ENDIF
+             ENDDO
+!
+!--          Vertical surfaces ( assumes the soil type given at respective (x,y) 
+             DO  l = 0, 3
+                DO  m = 1, surf_lsm_v(l)%ns
+                   i = surf_lsm_v(l)%i(m) + MERGE( 0, surf_lsm_v(l)%ioff,      &
+                                                   surf_lsm_v(l)%building_covered(m) ) 
+                   j = surf_lsm_v(l)%j(m) + MERGE( 0, surf_lsm_v(l)%joff,      &
+                                                   surf_lsm_v(l)%building_covered(m) ) 
+
+                   st = soil_type_f%var_2d(j,i)
+                   IF ( st /= soil_type_f%fill )  THEN
+                      surf_lsm_v(l)%alpha_vg(:,m)    = soil_pars(0,st)
+                      surf_lsm_v(l)%l_vg(:,m)        = soil_pars(1,st)
+                      surf_lsm_v(l)%n_vg(:,m)        = soil_pars(2,st)
+                      surf_lsm_v(l)%gamma_w_sat(:,m) = soil_pars(3,st)
+                      surf_lsm_v(l)%m_sat(:,m)       = soil_pars(4,st)
+                      surf_lsm_v(l)%m_fc(:,m)        = soil_pars(5,st)
+                      surf_lsm_v(l)%m_wilt(:,m)      = soil_pars(6,st)
+                      surf_lsm_v(l)%m_res(:,m)       = soil_pars(7,st)
+                   ENDIF
+                ENDDO
+             ENDDO
+!
+!--       Level of detail = 2, i.e. soil type and thus the soil parameters
+!--       can be heterogeneous along the vertical dimension. 
+          ELSE
+!
+!--          Horizontal surfaces
+             DO  m = 1, surf_lsm_h%ns
+                i = surf_lsm_h%i(m)
+                j = surf_lsm_h%j(m)
+             
+                DO  k = nzb_soil, nzt_soil
+                   st = soil_type_f%var_3d(k,j,i)
+                   IF ( st /= soil_type_f%fill )  THEN
+                      surf_lsm_h%alpha_vg(k,m)    = soil_pars(0,st)
+                      surf_lsm_h%l_vg(k,m)        = soil_pars(1,st)
+                      surf_lsm_h%n_vg(k,m)        = soil_pars(2,st)
+                      surf_lsm_h%gamma_w_sat(k,m) = soil_pars(3,st)
+                      surf_lsm_h%m_sat(k,m)       = soil_pars(4,st)
+                      surf_lsm_h%m_fc(k,m)        = soil_pars(5,st)
+                      surf_lsm_h%m_wilt(k,m)      = soil_pars(6,st)
+                      surf_lsm_h%m_res(k,m)       = soil_pars(7,st)
+                   ENDIF
+                ENDDO
+             ENDDO
+!
+!--          Vertical surfaces ( assumes the soil type given at respective (x,y) 
+             DO  l = 0, 3
+                DO  m = 1, surf_lsm_v(l)%ns
+                   i = surf_lsm_v(l)%i(m) + MERGE( 0, surf_lsm_v(l)%ioff,      &
+                                                   surf_lsm_v(l)%building_covered(m) ) 
+                   j = surf_lsm_v(l)%j(m) + MERGE( 0, surf_lsm_v(l)%joff,      &
+                                                   surf_lsm_v(l)%building_covered(m) ) 
+
+                   DO  k = nzb_soil, nzt_soil
+                      st = soil_type_f%var_3d(k,j,i)
+                      IF ( st /= soil_type_f%fill )  THEN
+                         surf_lsm_v(l)%alpha_vg(k,m)    = soil_pars(0,st)
+                         surf_lsm_v(l)%l_vg(k,m)        = soil_pars(1,st)
+                         surf_lsm_v(l)%n_vg(k,m)        = soil_pars(2,st)
+                         surf_lsm_v(l)%gamma_w_sat(k,m) = soil_pars(3,st)
+                         surf_lsm_v(l)%m_sat(k,m)       = soil_pars(4,st)
+                         surf_lsm_v(l)%m_fc(k,m)        = soil_pars(5,st)
+                         surf_lsm_v(l)%m_wilt(k,m)      = soil_pars(6,st)
+                         surf_lsm_v(l)%m_res(k,m)       = soil_pars(7,st)
+                      ENDIF
+                   ENDDO
+                ENDDO
+             ENDDO
+          ENDIF
+       ENDIF
+!
+!--    Level 3, initialization of single soil parameters at single z,x,y 
+!--    position via soil_pars read from file.
+       IF ( soil_pars_f%from_file )  THEN
+!
+!--       Level of detail = 1, i.e. a homogeneous vertical distribution of soil 
+!--       parameters is assumed.
+!--       Horizontal surfaces
+          IF ( soil_pars_f%lod == 1 )  THEN
+!
+!--          Horizontal surfaces 
+             DO  m = 1, surf_lsm_h%ns
+                i = surf_lsm_h%i(m)
+                j = surf_lsm_h%j(m)
+
+                IF ( soil_pars_f%pars_xy(0,j,i) /= soil_pars_f%fill )              &
+                   surf_lsm_h%alpha_vg(:,m)    = soil_pars_f%pars_xy(0,j,i)
+                IF ( soil_pars_f%pars_xy(1,j,i) /= soil_pars_f%fill )              &
+                   surf_lsm_h%l_vg(:,m)        = soil_pars_f%pars_xy(1,j,i)
+                IF ( soil_pars_f%pars_xy(2,j,i) /= soil_pars_f%fill )              &
+                   surf_lsm_h%n_vg(:,m)        = soil_pars_f%pars_xy(2,j,i)
+                IF ( soil_pars_f%pars_xy(3,j,i) /= soil_pars_f%fill )              &
+                   surf_lsm_h%gamma_w_sat(:,m) = soil_pars_f%pars_xy(3,j,i)
+                IF ( soil_pars_f%pars_xy(4,j,i) /= soil_pars_f%fill )              &
+                   surf_lsm_h%m_sat(:,m)       = soil_pars_f%pars_xy(4,j,i)
+                IF ( soil_pars_f%pars_xy(5,j,i) /= soil_pars_f%fill )              &
+                   surf_lsm_h%m_fc(:,m)        = soil_pars_f%pars_xy(5,j,i)
+                IF ( soil_pars_f%pars_xy(6,j,i) /= soil_pars_f%fill )              &
+                   surf_lsm_h%m_wilt(:,m)      = soil_pars_f%pars_xy(6,j,i)
+                IF ( soil_pars_f%pars_xy(7,j,i) /= soil_pars_f%fill )              &
+                   surf_lsm_h%m_res(:,m)       = soil_pars_f%pars_xy(7,j,i)
+
+             ENDDO
+!
+!--          Vertical surfaces 
+             DO  l = 0, 3
+                DO  m = 1, surf_lsm_v(l)%ns
+                   i = surf_lsm_v(l)%i(m) + MERGE( 0, surf_lsm_v(l)%ioff,      &
+                                                   surf_lsm_v(l)%building_covered(m) ) 
+                   j = surf_lsm_v(l)%j(m) + MERGE( 0, surf_lsm_v(l)%joff,      &
+                                                   surf_lsm_v(l)%building_covered(m) ) 
+
+                   IF ( soil_pars_f%pars_xy(0,j,i) /= soil_pars_f%fill )           &
+                      surf_lsm_v(l)%alpha_vg(:,m)    = soil_pars_f%pars_xy(0,j,i)
+                   IF ( soil_pars_f%pars_xy(1,j,i) /= soil_pars_f%fill )           &
+                      surf_lsm_v(l)%l_vg(:,m)        = soil_pars_f%pars_xy(1,j,i)
+                   IF ( soil_pars_f%pars_xy(2,j,i) /= soil_pars_f%fill )           &
+                      surf_lsm_v(l)%n_vg(:,m)        = soil_pars_f%pars_xy(2,j,i)
+                   IF ( soil_pars_f%pars_xy(3,j,i) /= soil_pars_f%fill )           &
+                      surf_lsm_v(l)%gamma_w_sat(:,m) = soil_pars_f%pars_xy(3,j,i)
+                   IF ( soil_pars_f%pars_xy(4,j,i) /= soil_pars_f%fill )           &
+                      surf_lsm_v(l)%m_sat(:,m)       = soil_pars_f%pars_xy(4,j,i)
+                   IF ( soil_pars_f%pars_xy(5,j,i) /= soil_pars_f%fill )           &
+                      surf_lsm_v(l)%m_fc(:,m)        = soil_pars_f%pars_xy(5,j,i)
+                   IF ( soil_pars_f%pars_xy(6,j,i) /= soil_pars_f%fill )           &
+                      surf_lsm_v(l)%m_wilt(:,m)      = soil_pars_f%pars_xy(6,j,i)
+                   IF ( soil_pars_f%pars_xy(7,j,i) /= soil_pars_f%fill )           &
+                      surf_lsm_v(l)%m_res(:,m)       = soil_pars_f%pars_xy(7,j,i)
+
+                ENDDO
+             ENDDO
+!
+!--       Level of detail = 2, i.e. soil parameters can be set at each soil 
+!--       layer individually. 
+          ELSE
+!
+!--          Horizontal surfaces
+             DO  m = 1, surf_lsm_h%ns
+                i = surf_lsm_h%i(m)
+                j = surf_lsm_h%j(m)
+
+                DO  k = nzb_soil, nzt_soil
+                   IF ( soil_pars_f%pars_xyz(0,k,j,i) /= soil_pars_f%fill )        &
+                      surf_lsm_h%alpha_vg(k,m)    = soil_pars_f%pars_xyz(0,k,j,i)
+                   IF ( soil_pars_f%pars_xyz(1,k,j,i) /= soil_pars_f%fill )        &
+                      surf_lsm_h%l_vg(k,m)        = soil_pars_f%pars_xyz(1,k,j,i)
+                   IF ( soil_pars_f%pars_xyz(2,k,j,i) /= soil_pars_f%fill )        &
+                      surf_lsm_h%n_vg(k,m)        = soil_pars_f%pars_xyz(2,k,j,i)
+                   IF ( soil_pars_f%pars_xyz(3,k,j,i) /= soil_pars_f%fill )        &
+                      surf_lsm_h%gamma_w_sat(k,m) = soil_pars_f%pars_xyz(3,k,j,i)
+                   IF ( soil_pars_f%pars_xyz(4,k,j,i) /= soil_pars_f%fill )        &
+                      surf_lsm_h%m_sat(k,m)       = soil_pars_f%pars_xyz(4,k,j,i)
+                   IF ( soil_pars_f%pars_xyz(5,k,j,i) /= soil_pars_f%fill )        &
+                      surf_lsm_h%m_fc(k,m)        = soil_pars_f%pars_xyz(5,k,j,i)
+                   IF ( soil_pars_f%pars_xyz(6,k,j,i) /= soil_pars_f%fill )        &
+                      surf_lsm_h%m_wilt(k,m)      = soil_pars_f%pars_xyz(6,k,j,i)
+                   IF ( soil_pars_f%pars_xyz(7,k,j,i) /= soil_pars_f%fill )        &
+                      surf_lsm_h%m_res(k,m)       = soil_pars_f%pars_xyz(7,k,j,i)
+                ENDDO
+
+             ENDDO
+!
+!--          Vertical surfaces 
+             DO  l = 0, 3
+                DO  m = 1, surf_lsm_v(l)%ns
+                   i = surf_lsm_v(l)%i(m) + MERGE( 0, surf_lsm_v(l)%ioff,      &
+                                                   surf_lsm_v(l)%building_covered(m) ) 
+                   j = surf_lsm_v(l)%j(m) + MERGE( 0, surf_lsm_v(l)%joff,      &
+                                                   surf_lsm_v(l)%building_covered(m) ) 
+
+                   DO  k = nzb_soil, nzt_soil
+                      IF ( soil_pars_f%pars_xyz(0,k,j,i) /= soil_pars_f%fill )        &
+                         surf_lsm_v(l)%alpha_vg(k,m)    = soil_pars_f%pars_xyz(0,k,j,i)
+                      IF ( soil_pars_f%pars_xyz(1,k,j,i) /= soil_pars_f%fill )        &
+                         surf_lsm_v(l)%l_vg(k,m)        = soil_pars_f%pars_xyz(1,k,j,i)
+                      IF ( soil_pars_f%pars_xyz(2,k,j,i) /= soil_pars_f%fill )        &
+                         surf_lsm_v(l)%n_vg(k,m)        = soil_pars_f%pars_xyz(2,k,j,i)
+                      IF ( soil_pars_f%pars_xyz(3,k,j,i) /= soil_pars_f%fill )        &
+                         surf_lsm_v(l)%gamma_w_sat(k,m) = soil_pars_f%pars_xyz(3,k,j,i)
+                      IF ( soil_pars_f%pars_xyz(4,k,j,i) /= soil_pars_f%fill )        &
+                         surf_lsm_v(l)%m_sat(k,m)       = soil_pars_f%pars_xyz(4,k,j,i)
+                      IF ( soil_pars_f%pars_xyz(5,k,j,i) /= soil_pars_f%fill )        &
+                         surf_lsm_v(l)%m_fc(k,m)        = soil_pars_f%pars_xyz(5,k,j,i)
+                      IF ( soil_pars_f%pars_xyz(6,k,j,i) /= soil_pars_f%fill )        &
+                         surf_lsm_v(l)%m_wilt(k,m)      = soil_pars_f%pars_xyz(6,k,j,i)
+                      IF ( soil_pars_f%pars_xyz(7,k,j,i) /= soil_pars_f%fill )        &
+                         surf_lsm_v(l)%m_res(k,m)       = soil_pars_f%pars_xyz(7,k,j,i)
+                   ENDDO
+
+                ENDDO
+             ENDDO
+
+          ENDIF
+       ENDIF
+
+!
+!--    Level 1, initialization of vegetation parameters. A horizontally 
+!--    homogeneous distribution is assumed here. 
+       IF ( vegetation_type /= 0 )  THEN
+
+          IF ( min_canopy_resistance == 9999999.9_wp )  THEN
+             min_canopy_resistance = vegetation_pars(ind_v_rc_min,vegetation_type)
+          ENDIF
+
+          IF ( leaf_area_index == 9999999.9_wp )  THEN
+             leaf_area_index = vegetation_pars(ind_v_rc_lai,vegetation_type)         
+          ENDIF
+
+          IF ( vegetation_coverage == 9999999.9_wp )  THEN
+             vegetation_coverage = vegetation_pars(ind_v_c_veg,vegetation_type)     
+          ENDIF
+
+          IF ( canopy_resistance_coefficient == 9999999.9_wp )  THEN
+              canopy_resistance_coefficient= vegetation_pars(ind_v_gd,vegetation_type)     
+          ENDIF
+
+          IF ( z0_vegetation == 9999999.9_wp )  THEN
+             z0_vegetation  = vegetation_pars(ind_v_z0,vegetation_type) 
+          ENDIF
+
+          IF ( z0h_vegetation == 9999999.9_wp )  THEN
+             z0h_vegetation = vegetation_pars(ind_v_z0qh,vegetation_type)
+          ENDIF   
+          
+          IF ( lambda_surface_stable == 9999999.9_wp )  THEN
+             lambda_surface_stable = vegetation_pars(ind_v_lambda_s,vegetation_type) 
+          ENDIF
+
+          IF ( lambda_surface_unstable == 9999999.9_wp )  THEN
+             lambda_surface_unstable = vegetation_pars(ind_v_lambda_u,vegetation_type)           
+          ENDIF
+
+          IF ( f_shortwave_incoming == 9999999.9_wp )  THEN
+             f_shortwave_incoming = vegetation_pars(ind_v_f_sw_in,vegetation_type)        
+          ENDIF
+
+          IF ( c_surface == 9999999.9_wp )  THEN
+             c_surface = vegetation_pars(ind_v_c_surf,vegetation_type)        
+          ENDIF
+
+          IF ( albedo_type == 9999999  .AND.  albedo == 9999999.9_wp )  THEN
+             albedo_type = INT(vegetation_pars(ind_v_at,vegetation_type))       
+          ENDIF
+   
+          IF ( emissivity == 9999999.9_wp )  THEN
+             emissivity = vegetation_pars(ind_v_emis,vegetation_type)     
+          ENDIF
+
+       ENDIF
+!
+!--    Map values onto horizontal elemements
+       DO  m = 1, surf_lsm_h%ns
+          IF ( surf_lsm_h%vegetation_surface(m) )  THEN
+             surf_lsm_h%r_canopy_min(m)     = min_canopy_resistance
+             surf_lsm_h%lai(m)              = leaf_area_index
+             surf_lsm_h%c_veg(m)            = vegetation_coverage
+             surf_lsm_h%g_d(m)              = canopy_resistance_coefficient
+             surf_lsm_h%z0(m)               = z0_vegetation
+             surf_lsm_h%z0h(m)              = z0h_vegetation
+             surf_lsm_h%z0q(m)              = z0h_vegetation
+             surf_lsm_h%lambda_surface_s(m) = lambda_surface_stable
+             surf_lsm_h%lambda_surface_u(m) = lambda_surface_unstable
+             surf_lsm_h%f_sw_in(m)          = f_shortwave_incoming
+             surf_lsm_h%c_surface(m)        = c_surface
+             surf_lsm_h%albedo_type(ind_veg,m) = albedo_type
+             surf_lsm_h%emissivity(ind_veg,m)  = emissivity
+          ELSE
+             surf_lsm_h%lai(m)   = 0.0_wp
+             surf_lsm_h%c_veg(m) = 0.0_wp
+             surf_lsm_h%g_d(m)   = 0.0_wp
+          ENDIF
+  
+       ENDDO
+!
+!--    Map values onto vertical elements, even though this does not make
+!--    much sense.
+       DO  l = 0, 3
+          DO  m = 1, surf_lsm_v(l)%ns
+             IF ( surf_lsm_v(l)%vegetation_surface(m) )  THEN
+                surf_lsm_v(l)%r_canopy_min(m)     = min_canopy_resistance
+                surf_lsm_v(l)%lai(m)              = leaf_area_index
+                surf_lsm_v(l)%c_veg(m)            = vegetation_coverage
+                surf_lsm_v(l)%g_d(m)              = canopy_resistance_coefficient
+                surf_lsm_v(l)%z0(m)               = z0_vegetation
+                surf_lsm_v(l)%z0h(m)              = z0h_vegetation
+                surf_lsm_v(l)%z0q(m)              = z0h_vegetation
+                surf_lsm_v(l)%lambda_surface_s(m) = lambda_surface_stable
+                surf_lsm_v(l)%lambda_surface_u(m) = lambda_surface_unstable
+                surf_lsm_v(l)%f_sw_in(m)          = f_shortwave_incoming
+                surf_lsm_v(l)%c_surface(m)        = c_surface
+                surf_lsm_v(l)%albedo_type(ind_veg,m) = albedo_type
+                surf_lsm_v(l)%emissivity(ind_veg,m)  = emissivity
+             ELSE
+                surf_lsm_v(l)%lai(m)   = 0.0_wp
+                surf_lsm_v(l)%c_veg(m) = 0.0_wp
+                surf_lsm_v(l)%g_d(m)   = 0.0_wp
+             ENDIF
+          ENDDO
+       ENDDO
+
+!
+!--    Level 2, initialization of vegation parameters via vegetation_type read
+!--    from file. Vegetation parameters are initialized for each (y,x)-grid point 
+!--    individually using default paramter settings according to the given
+!--    vegetation type.
+       IF ( vegetation_type_f%from_file )  THEN
+!
+!--       Horizontal surfaces
+          DO  m = 1, surf_lsm_h%ns
+             i = surf_lsm_h%i(m)
+             j = surf_lsm_h%j(m)
+             
+             st = vegetation_type_f%var(j,i)
+             IF ( st /= vegetation_type_f%fill  .AND.  st /= 0 )  THEN
+                surf_lsm_h%r_canopy_min(m)     = vegetation_pars(ind_v_rc_min,st)
+                surf_lsm_h%lai(m)              = vegetation_pars(ind_v_rc_lai,st)
+                surf_lsm_h%c_veg(m)            = vegetation_pars(ind_v_c_veg,st)
+                surf_lsm_h%g_d(m)              = vegetation_pars(ind_v_gd,st)
+                surf_lsm_h%z0(m)               = vegetation_pars(ind_v_z0,st)
+                surf_lsm_h%z0h(m)              = vegetation_pars(ind_v_z0qh,st)
+                surf_lsm_h%z0q(m)              = vegetation_pars(ind_v_z0qh,st)
+                surf_lsm_h%lambda_surface_s(m) = vegetation_pars(ind_v_lambda_s,st)
+                surf_lsm_h%lambda_surface_u(m) = vegetation_pars(ind_v_lambda_u,st)
+                surf_lsm_h%f_sw_in(m)          = vegetation_pars(ind_v_f_sw_in,st)
+                surf_lsm_h%c_surface(m)        = vegetation_pars(ind_v_c_surf,st)
+                surf_lsm_h%albedo_type(ind_veg,m) = INT( vegetation_pars(ind_v_at,st) )
+                surf_lsm_h%emissivity(ind_veg,m)  = vegetation_pars(ind_v_emis,st)
+             ENDIF
+          ENDDO
+!
+!--       Vertical surfaces
+          DO  l = 0, 3
+             DO  m = 1, surf_lsm_v(l)%ns
+                i = surf_lsm_v(l)%i(m) + MERGE( 0, surf_lsm_v(l)%ioff,      &
+                                                surf_lsm_v(l)%building_covered(m) ) 
+                j = surf_lsm_v(l)%j(m) + MERGE( 0, surf_lsm_v(l)%joff,      &
+                                                   surf_lsm_v(l)%building_covered(m) ) 
+             
+                st = vegetation_type_f%var(j,i)
+                IF ( st /= vegetation_type_f%fill  .AND.  st /= 0 )  THEN
+                   surf_lsm_v(l)%r_canopy_min(m)     = vegetation_pars(ind_v_rc_min,st)
+                   surf_lsm_v(l)%lai(m)              = vegetation_pars(ind_v_rc_lai,st)
+                   surf_lsm_v(l)%c_veg(m)            = vegetation_pars(ind_v_c_veg,st)
+                   surf_lsm_v(l)%g_d(m)              = vegetation_pars(ind_v_gd,st)
+                   surf_lsm_v(l)%z0(m)               = vegetation_pars(ind_v_z0,st)
+                   surf_lsm_v(l)%z0h(m)              = vegetation_pars(ind_v_z0qh,st)
+                   surf_lsm_v(l)%z0q(m)              = vegetation_pars(ind_v_z0qh,st)
+                   surf_lsm_v(l)%lambda_surface_s(m) = vegetation_pars(ind_v_lambda_s,st)
+                   surf_lsm_v(l)%lambda_surface_u(m) = vegetation_pars(ind_v_lambda_u,st)
+                   surf_lsm_v(l)%f_sw_in(m)          = vegetation_pars(ind_v_f_sw_in,st)
+                   surf_lsm_v(l)%c_surface(m)        = vegetation_pars(ind_v_c_surf,st)
+                   surf_lsm_v(l)%albedo_type(ind_veg,m) = INT( vegetation_pars(ind_v_at,st) )
+                   surf_lsm_v(l)%emissivity(ind_veg,m)  = vegetation_pars(ind_v_emis,st)
+                ENDIF
+             ENDDO
+          ENDDO
+       ENDIF
+!
+!--    Level 3, initialization of vegation parameters at single (x,y) 
+!--    position via vegetation_pars read from file.
+       IF ( vegetation_pars_f%from_file )  THEN
+!
+!--       Horizontal surfaces 
+          DO  m = 1, surf_lsm_h%ns
+
+             i = surf_lsm_h%i(m)
+             j = surf_lsm_h%j(m)
+!
+!--          If surface element is not a vegetation surface and any value in 
+!--          vegetation_pars is given, neglect this information and give an
+!--          informative message that this value will not be used.   
+             IF ( .NOT. surf_lsm_h%vegetation_surface(m)  .AND.                &
+                   ANY( vegetation_pars_f%pars_xy(:,j,i) /=                    &
+                   vegetation_pars_f%fill ) )  THEN
+                WRITE( message_string, * )                                     &
+                                 'surface element at grid point (j,i) = (',    &
+                                 j, i, ') is not a vegation surface, ',        &
+                                 'so that information given in ',              &
+                                 'vegetation_pars at this point is neglected.' 
+                CALL message( 'land_surface_model_mod', 'PA0999', 0, 0, 0, 6, 0 )
+             ELSE
+
+                IF ( vegetation_pars_f%pars_xy(ind_v_rc_min,j,i) /=            &
+                     vegetation_pars_f%fill )                                  &
+                   surf_lsm_h%r_canopy_min(m)  =                               &
+                                   vegetation_pars_f%pars_xy(ind_v_rc_min,j,i)
+                IF ( vegetation_pars_f%pars_xy(ind_v_rc_lai,j,i) /=            &
+                     vegetation_pars_f%fill )                                  &
+                   surf_lsm_h%lai(m)           =                               &
+                                   vegetation_pars_f%pars_xy(ind_v_rc_lai,j,i)
+                IF ( vegetation_pars_f%pars_xy(ind_v_c_veg,j,i) /=             &
+                     vegetation_pars_f%fill )                                  &
+                   surf_lsm_h%c_veg(m)         =                               &
+                                   vegetation_pars_f%pars_xy(ind_v_c_veg,j,i)
+                IF ( vegetation_pars_f%pars_xy(ind_v_gd,j,i) /=                &
+                     vegetation_pars_f%fill )                                  &
+                   surf_lsm_h%g_d(m)           =                               &
+                                   vegetation_pars_f%pars_xy(ind_v_gd,j,i)
+                IF ( vegetation_pars_f%pars_xy(ind_v_z0,j,i) /=                &
+                     vegetation_pars_f%fill )                                  &
+                   surf_lsm_h%z0(m)            =                               &
+                                   vegetation_pars_f%pars_xy(ind_v_z0,j,i)
+                IF ( vegetation_pars_f%pars_xy(ind_v_z0qh,j,i) /=              &
+                     vegetation_pars_f%fill )  THEN
+                   surf_lsm_h%z0h(m)           =                               &
+                                   vegetation_pars_f%pars_xy(ind_v_z0qh,j,i)
+                   surf_lsm_h%z0q(m)           =                               &
+                                   vegetation_pars_f%pars_xy(ind_v_z0qh,j,i)
+                ENDIF
+                IF ( vegetation_pars_f%pars_xy(ind_v_lambda_s,j,i) /=          &
+                     vegetation_pars_f%fill )                                  &
+                   surf_lsm_h%lambda_surface_s(m) =                            &
+                                   vegetation_pars_f%pars_xy(ind_v_lambda_s,j,i)
+                IF ( vegetation_pars_f%pars_xy(ind_v_lambda_u,j,i) /=          &
+                     vegetation_pars_f%fill )                                  &
+                   surf_lsm_h%lambda_surface_u(m) =                            &
+                                   vegetation_pars_f%pars_xy(ind_v_lambda_u,j,i)
+                IF ( vegetation_pars_f%pars_xy(ind_v_f_sw_in,j,i) /=           &
+                     vegetation_pars_f%fill )                                  &
+                   surf_lsm_h%f_sw_in(m)          =                            &
+                                   vegetation_pars_f%pars_xy(ind_v_f_sw_in,j,i)
+                IF ( vegetation_pars_f%pars_xy(ind_v_c_surf,j,i) /=            &
+                     vegetation_pars_f%fill )                                  &
+                   surf_lsm_h%c_surface(m)        =                            &
+                                   vegetation_pars_f%pars_xy(ind_v_c_surf,j,i)
+                IF ( vegetation_pars_f%pars_xy(ind_v_at,j,i) /=                &
+                     vegetation_pars_f%fill )                                  &
+                   surf_lsm_h%albedo_type(ind_veg,m) =                         &
+                                   INT( vegetation_pars_f%pars_xy(ind_v_at,j,i) )
+                IF ( vegetation_pars_f%pars_xy(ind_v_emis,j,i) /=              &
+                     vegetation_pars_f%fill )                                  &
+                   surf_lsm_h%emissivity(ind_veg,m)  =                         &
+                                   vegetation_pars_f%pars_xy(ind_v_emis,j,i)
+             ENDIF
+          ENDDO
+!
+!--       Vertical surfaces 
+          DO  l = 0, 3
+             DO  m = 1, surf_lsm_v(l)%ns
+                i = surf_lsm_v(l)%i(m) + MERGE( 0, surf_lsm_v(l)%ioff,         &
+                                                surf_lsm_v(l)%building_covered(m) ) 
+                j = surf_lsm_v(l)%j(m) + MERGE( 0, surf_lsm_v(l)%joff,         &
+                                                surf_lsm_v(l)%building_covered(m) ) 
+!
+!--             If surface element is not a vegetation surface and any value in 
+!--             vegetation_pars is given, neglect this information and give an
+!--             informative message that this value will not be used.   
+                IF ( .NOT. surf_lsm_v(l)%vegetation_surface(m)  .AND.          &
+                      ANY( vegetation_pars_f%pars_xy(:,j,i) /=                 &
+                      vegetation_pars_f%fill ) )  THEN
+                   WRITE( message_string, * )                                  &
+                                 'surface element at grid point (j,i) = (',    &
+                                 j, i, ') is not a vegation surface, ',        &
+                                 'so that information given in ',              &
+                                 'vegetation_pars at this point is neglected.' 
+                   CALL message( 'land_surface_model_mod', 'PA0999', 0, 0, 0, 6, 0 )
+                ELSE
+
+                   IF ( vegetation_pars_f%pars_xy(ind_v_rc_min,j,i) /=         &
+                        vegetation_pars_f%fill )                               &
+                      surf_lsm_v(l)%r_canopy_min(m)  =                         &
+                                   vegetation_pars_f%pars_xy(ind_v_rc_min,j,i)
+                   IF ( vegetation_pars_f%pars_xy(ind_v_rc_lai,j,i) /=         &
+                        vegetation_pars_f%fill )                               &
+                      surf_lsm_v(l)%lai(m)           =                         &
+                                   vegetation_pars_f%pars_xy(ind_v_rc_lai,j,i)
+                   IF ( vegetation_pars_f%pars_xy(ind_v_c_veg,j,i) /=          &
+                        vegetation_pars_f%fill )                               &
+                      surf_lsm_v(l)%c_veg(m)         =                         &
+                                   vegetation_pars_f%pars_xy(ind_v_c_veg,j,i)
+                   IF ( vegetation_pars_f%pars_xy(ind_v_gd,j,i) /=             &
+                        vegetation_pars_f%fill )                               &
+                     surf_lsm_v(l)%g_d(m)            =                         &
+                                   vegetation_pars_f%pars_xy(ind_v_gd,j,i)
+                   IF ( vegetation_pars_f%pars_xy(ind_v_z0,j,i) /=             &
+                        vegetation_pars_f%fill )                               &
+                      surf_lsm_v(l)%z0(m)            =                         &
+                                   vegetation_pars_f%pars_xy(ind_v_z0,j,i)
+                   IF ( vegetation_pars_f%pars_xy(ind_v_z0qh,j,i) /=           &
+                        vegetation_pars_f%fill )  THEN
+                      surf_lsm_v(l)%z0h(m)           =                         &
+                                   vegetation_pars_f%pars_xy(ind_v_z0qh,j,i)
+                      surf_lsm_v(l)%z0q(m)           =                         &
+                                   vegetation_pars_f%pars_xy(ind_v_z0qh,j,i)
+                   ENDIF
+                   IF ( vegetation_pars_f%pars_xy(ind_v_lambda_s,j,i) /=       &
+                        vegetation_pars_f%fill )                               &
+                      surf_lsm_v(l)%lambda_surface_s(m)  =                     &
+                                   vegetation_pars_f%pars_xy(ind_v_lambda_s,j,i)
+                   IF ( vegetation_pars_f%pars_xy(ind_v_lambda_u,j,i) /=       &
+                        vegetation_pars_f%fill )                               &
+                      surf_lsm_v(l)%lambda_surface_u(m)  =                     &
+                                   vegetation_pars_f%pars_xy(ind_v_lambda_u,j,i)
+                   IF ( vegetation_pars_f%pars_xy(ind_v_f_sw_in,j,i) /=        &
+                        vegetation_pars_f%fill )                               &
+                      surf_lsm_v(l)%f_sw_in(m)           =                     &
+                                   vegetation_pars_f%pars_xy(ind_v_f_sw_in,j,i)
+                   IF ( vegetation_pars_f%pars_xy(ind_v_c_surf,j,i) /=         &
+                        vegetation_pars_f%fill )                               &
+                      surf_lsm_v(l)%c_surface(m)         =                     &
+                                   vegetation_pars_f%pars_xy(ind_v_c_surf,j,i)
+                   IF ( vegetation_pars_f%pars_xy(ind_v_at,j,i) /=             &
+                        vegetation_pars_f%fill )                               &
+                      surf_lsm_v(l)%albedo_type(ind_veg,m) =                   &
+                                   INT( vegetation_pars_f%pars_xy(ind_v_at,j,i) )
+                   IF ( vegetation_pars_f%pars_xy(ind_v_emis,j,i) /=           &
+                        vegetation_pars_f%fill )                               &
+                      surf_lsm_v(l)%emissivity(ind_veg,m)  =                   &
+                                   vegetation_pars_f%pars_xy(ind_v_emis,j,i)
+                ENDIF
+
+             ENDDO
+          ENDDO
+       ENDIF 
+
+!
+!--    Level 1, initialization of water parameters. A horizontally 
+!--    homogeneous distribution is assumed here. 
+       IF ( water_type /= 0 )  THEN
+
+          IF ( water_temperature == 9999999.9_wp )  THEN
+             water_temperature = water_pars(ind_w_temp,water_type)       
+          ENDIF
+
+          IF ( z0_water == 9999999.9_wp )  THEN
+             z0_water = water_pars(ind_w_z0,water_type)       
+          ENDIF       
+
+          IF ( z0h_water == 9999999.9_wp )  THEN
+             z0h_water = water_pars(ind_w_z0h,water_type)       
+          ENDIF  
+
+          IF ( albedo_type == 9999999  .AND.  albedo == 9999999.9_wp )  THEN
+             albedo_type = INT(water_pars(ind_w_at,water_type))        
+          ENDIF
+   
+          IF ( emissivity == 9999999.9_wp )  THEN
+             emissivity = water_pars(ind_w_emis,water_type)        
+          ENDIF
+
+       ENDIF 
+!
+!--    Map values onto horizontal elemements
+       DO  m = 1, surf_lsm_h%ns
+          IF ( surf_lsm_h%water_surface(m) )  THEN
+             IF ( TRIM( initializing_actions ) /= 'read_restart_data' )        &
+                t_soil_h%var_2d(:,m)           = water_temperature
+             surf_lsm_h%z0(m)               = z0_water
+             surf_lsm_h%z0h(m)              = z0h_water
+             surf_lsm_h%z0q(m)              = z0h_water
+             surf_lsm_h%lambda_surface_s(m) = 1.0E10_wp
+             surf_lsm_h%lambda_surface_u(m) = 1.0E10_wp               
+             surf_lsm_h%c_surface(m)        = 0.0_wp
+             surf_lsm_h%albedo_type(ind_wat,m) = albedo_type
+             surf_lsm_h%emissivity(ind_wat,m)  = emissivity
+          ENDIF
+       ENDDO
+!
+!--    Map values onto vertical elements, even though this does not make
+!--    much sense.
+       DO  l = 0, 3
+          DO  m = 1, surf_lsm_v(l)%ns
+             IF ( surf_lsm_v(l)%water_surface(m) )  THEN
+                IF ( TRIM( initializing_actions ) /= 'read_restart_data' )     &
+                   t_soil_v(l)%var_2d(:,m)           = water_temperature
+                surf_lsm_v(l)%z0(m)               = z0_water
+                surf_lsm_v(l)%z0h(m)              = z0h_water
+                surf_lsm_v(l)%z0q(m)              = z0h_water
+                surf_lsm_v(l)%lambda_surface_s(m) = 1.0E10_wp
+                surf_lsm_v(l)%lambda_surface_u(m) = 1.0E10_wp               
+                surf_lsm_v(l)%c_surface(m)        = 0.0_wp
+                surf_lsm_v(l)%albedo_type(ind_wat,m) = albedo_type
+                surf_lsm_v(l)%emissivity(ind_wat,m)  = emissivity
+             ENDIF 
+          ENDDO
+       ENDDO
+!
+!
+!--    Level 2, initialization of water parameters via water_type read
+!--    from file. Water surfaces are initialized for each (y,x)-grid point 
+!--    individually using default paramter settings according to the given
+!--    water type.
+!--    Note, parameter 3/4 of water_pars are albedo and emissivity,
+!--    whereas paramter 3/4 of water_pars_f are heat conductivities!
+       IF ( water_type_f%from_file )  THEN
+!
+!--       Horizontal surfaces
+          DO  m = 1, surf_lsm_h%ns
+             i = surf_lsm_h%i(m)
+             j = surf_lsm_h%j(m)
+             
+             st = water_type_f%var(j,i)
+             IF ( st /= water_type_f%fill  .AND.  st /= 0 )  THEN
+                IF ( TRIM( initializing_actions ) /= 'read_restart_data' )     &
+                   t_soil_h%var_2d(:,m) = water_pars(ind_w_temp,st)
+                surf_lsm_h%z0(m)     = water_pars(ind_w_z0,st)
+                surf_lsm_h%z0h(m)    = water_pars(ind_w_z0h,st)
+                surf_lsm_h%z0q(m)    = water_pars(ind_w_z0h,st)
+                surf_lsm_h%lambda_surface_s(m) = water_pars(ind_w_lambda_s,st)
+                surf_lsm_h%lambda_surface_u(m) = water_pars(ind_w_lambda_u,st)              
+                surf_lsm_h%c_surface(m)        = 0.0_wp
+                surf_lsm_h%albedo_type(ind_wat,m) = INT( water_pars(ind_w_at,st) )
+                surf_lsm_h%emissivity(ind_wat,m)  = water_pars(ind_w_emis,st)
+             ENDIF
+          ENDDO
+!
+!--       Vertical surfaces
+          DO  l = 0, 3
+             DO  m = 1, surf_lsm_v(l)%ns
+                i = surf_lsm_v(l)%i(m) + MERGE( 0, surf_lsm_v(l)%ioff,         &
+                                                surf_lsm_v(l)%building_covered(m) ) 
+                j = surf_lsm_v(l)%j(m) + MERGE( 0, surf_lsm_v(l)%joff,         &
+                                                surf_lsm_v(l)%building_covered(m) ) 
+             
+                st = water_type_f%var(j,i)
+                IF ( st /= water_type_f%fill  .AND.  st /= 0 )  THEN
+                   IF ( TRIM( initializing_actions ) /= 'read_restart_data' )  &
+                      t_soil_v(l)%var_2d(:,m) = water_pars(ind_w_temp,st)
+                   surf_lsm_v(l)%z0(m)     = water_pars(ind_w_z0,st)
+                   surf_lsm_v(l)%z0h(m)    = water_pars(ind_w_z0h,st)
+                   surf_lsm_v(l)%z0q(m)    = water_pars(ind_w_z0h,st)
+                   surf_lsm_v(l)%lambda_surface_s(m) =                         &
+                                                   water_pars(ind_w_lambda_s,st)
+                   surf_lsm_v(l)%lambda_surface_u(m) =                         &
+                                                   water_pars(ind_w_lambda_u,st)           
+                   surf_lsm_v(l)%c_surface(m)     = 0.0_wp
+                   surf_lsm_v(l)%albedo_type(ind_wat,m) =                      &
+                                                  INT( water_pars(ind_w_at,st) )
+                   surf_lsm_v(l)%emissivity(ind_wat,m)  =                      &
+                                                  water_pars(ind_w_emis,st)
+                ENDIF
+             ENDDO
+          ENDDO
+       ENDIF      
+
+!
+!--    Level 3, initialization of water parameters at single (x,y) 
+!--    position via water_pars read from file.
+       IF ( water_pars_f%from_file )  THEN
+!
+!--       Horizontal surfaces 
+          DO  m = 1, surf_lsm_h%ns
+             i = surf_lsm_h%i(m)
+             j = surf_lsm_h%j(m)
+!
+!--          If surface element is not a water surface and any value in 
+!--          water_pars is given, neglect this information and give an
+!--          informative message that this value will not be used.   
+             IF ( .NOT. surf_lsm_h%water_surface(m)  .AND.                     &
+                   ANY( water_pars_f%pars_xy(:,j,i) /= water_pars_f%fill ) )  THEN
+                WRITE( message_string, * )                                     &
+                              'surface element at grid point (j,i) = (',       &
+                              j, i, ') is not a water surface, ',              &
+                              'so that information given in ',                 &
+                              'water_pars at this point is neglected.' 
+                CALL message( 'land_surface_model_mod', 'PA0999', 0, 0, 0, 6, 0 )
+             ELSE
+                IF ( water_pars_f%pars_xy(ind_w_temp,j,i) /=                   &
+                     water_pars_f%fill  .AND.                                  &
+                     TRIM( initializing_actions ) /= 'read_restart_data' )     &
+                      t_soil_h%var_2d(:,m) = water_pars_f%pars_xy(ind_w_temp,j,i)
+
+                IF ( water_pars_f%pars_xy(ind_w_z0,j,i) /= water_pars_f%fill ) &
+                   surf_lsm_h%z0(m)     = water_pars_f%pars_xy(ind_w_z0,j,i)
+
+                IF ( water_pars_f%pars_xy(ind_w_z0h,j,i) /= water_pars_f%fill )&
+                THEN
+                   surf_lsm_h%z0h(m)    = water_pars_f%pars_xy(ind_w_z0h,j,i)
+                   surf_lsm_h%z0q(m)    = water_pars_f%pars_xy(ind_w_z0h,j,i)
+                ENDIF
+
+                IF ( water_pars_f%pars_xy(ind_w_lambda_s,j,i) /=               &
+                     water_pars_f%fill )                                       &
+                   surf_lsm_h%lambda_surface_s(m) =                            &
+                                        water_pars_f%pars_xy(ind_w_lambda_s,j,i)
+
+                IF ( water_pars_f%pars_xy(ind_w_lambda_u,j,i) /=               &
+                      water_pars_f%fill )                                      &
+                   surf_lsm_h%lambda_surface_u(m) =                            &
+                                        water_pars_f%pars_xy(ind_w_lambda_u,j,i)     
+       
+                IF ( water_pars_f%pars_xy(ind_w_at,j,i) /=                     &
+                     water_pars_f%fill )                                       &
+                   surf_lsm_h%albedo_type(ind_wat,m) =                         &
+                                       INT( water_pars_f%pars_xy(ind_w_at,j,i) )
+
+                IF ( water_pars_f%pars_xy(ind_w_emis,j,i) /=                   &
+                     water_pars_f%fill )                                       &
+                   surf_lsm_h%emissivity(ind_wat,m) =                          &
+                   water_pars_f%pars_xy(ind_w_emis,j,i)  
+             ENDIF
+          ENDDO
+!
+!--       Vertical surfaces 
+          DO  l = 0, 3
+             DO  m = 1, surf_lsm_v(l)%ns
+                i = surf_lsm_v(l)%i(m) + MERGE( 0, surf_lsm_v(l)%ioff,         &
+                                                surf_lsm_v(l)%building_covered(m) ) 
+                j = surf_lsm_v(l)%j(m) + MERGE( 0, surf_lsm_v(l)%joff,         &
+                                                surf_lsm_v(l)%building_covered(m) ) 
+!
+!--             If surface element is not a water surface and any value in 
+!--             water_pars is given, neglect this information and give an
+!--             informative message that this value will not be used.   
+                IF ( .NOT. surf_lsm_v(l)%water_surface(m)  .AND.               &
+                      ANY( water_pars_f%pars_xy(:,j,i) /=                      &
+                      water_pars_f%fill ) )  THEN
+                   WRITE( message_string, * )                                  &
+                              'surface element at grid point (j,i) = (',       &
+                              j, i, ') is not a water surface, ',              &
+                              'so that information given in ',                 &
+                              'water_pars at this point is neglected.' 
+                   CALL message( 'land_surface_model_mod', 'PA0999',           &
+                                  0, 0, 0, 6, 0 )
+                ELSE
+
+                   IF ( water_pars_f%pars_xy(ind_w_temp,j,i) /=                &
+                     water_pars_f%fill  .AND.                                  &
+                     TRIM( initializing_actions ) /= 'read_restart_data' )     &
+                      t_soil_v(l)%var_2d(:,m) = water_pars_f%pars_xy(ind_w_temp,j,i)
+
+                   IF ( water_pars_f%pars_xy(ind_w_z0,j,i) /=                  &
+                        water_pars_f%fill )                                    &
+                      surf_lsm_v(l)%z0(m)   = water_pars_f%pars_xy(ind_w_z0,j,i)
+
+                   IF ( water_pars_f%pars_xy(ind_w_z0h,j,i) /=                 &
+                       water_pars_f%fill )  THEN
+                      surf_lsm_v(l)%z0h(m)  = water_pars_f%pars_xy(ind_w_z0h,j,i)
+                      surf_lsm_v(l)%z0q(m)  = water_pars_f%pars_xy(ind_w_z0h,j,i)
+                   ENDIF
+
+                   IF ( water_pars_f%pars_xy(ind_w_lambda_s,j,i) /=            &
+                        water_pars_f%fill )                                    &
+                      surf_lsm_v(l)%lambda_surface_s(m) =                      &
+                                      water_pars_f%pars_xy(ind_w_lambda_s,j,i)
+
+                   IF ( water_pars_f%pars_xy(ind_w_lambda_u,j,i) /=            &
+                        water_pars_f%fill )                                    &
+                      surf_lsm_v(l)%lambda_surface_u(m) =                      &
+                                      water_pars_f%pars_xy(ind_w_lambda_u,j,i)    
+ 
+                   IF ( water_pars_f%pars_xy(ind_w_at,j,i) /=                  &
+                        water_pars_f%fill )                                    &
+                      surf_lsm_v(l)%albedo_type(ind_wat,m)    =                &
+                                      INT( water_pars_f%pars_xy(ind_w_at,j,i) )
+
+                   IF ( water_pars_f%pars_xy(ind_w_emis,j,i) /=                &
+                        water_pars_f%fill )                                    &
+                      surf_lsm_v(l)%emissivity(ind_wat,m)     =                &
+                                      water_pars_f%pars_xy(ind_w_emis,j,i)  
+                ENDIF
+             ENDDO
+          ENDDO
+
+       ENDIF
+!
+!--    Initialize pavement-type surfaces, level 1
+       IF ( pavement_type /= 0 )  THEN  
+
+!
+!--       When a pavement_type is used, overwrite a possible setting of 
+!--       the pavement depth as it is already defined by the pavement type
+          pavement_depth_level = 0
+
+          IF ( z0_pavement == 9999999.9_wp )  THEN
+             z0_pavement  = pavement_pars(ind_p_z0,pavement_type) 
+          ENDIF
+
+          IF ( z0h_pavement == 9999999.9_wp )  THEN
+             z0h_pavement = pavement_pars(ind_p_z0h,pavement_type)
+          ENDIF
+
+          IF ( pavement_heat_conduct == 9999999.9_wp )  THEN
+             pavement_heat_conduct = pavement_subsurface_pars_1(0,pavement_type)
+          ENDIF
+
+          IF ( pavement_heat_capacity == 9999999.9_wp )  THEN
+             pavement_heat_capacity = pavement_subsurface_pars_2(0,pavement_type)
+          ENDIF   
+    
+          IF ( albedo_type == 9999999  .AND.  albedo == 9999999.9_wp )  THEN
+             albedo_type = INT(pavement_pars(ind_p_at,pavement_type))        
+          ENDIF
+   
+          IF ( emissivity == 9999999.9_wp )  THEN
+             emissivity = pavement_pars(ind_p_emis,pavement_type)        
+          ENDIF
+
+!
+!--       If the depth level of the pavement is not set, determine it from
+!--       lookup table.
+          IF ( pavement_depth_level == 0 )  THEN
+             DO  k = nzb_soil, nzt_soil  
+                IF ( pavement_subsurface_pars_1(k,pavement_type) == 9999999.9_wp &
+                .OR. pavement_subsurface_pars_2(k,pavement_type) == 9999999.9_wp)&
+                THEN
+                   nzt_pavement = k-1
+                   EXIT
+                ENDIF
+             ENDDO
+          ELSE
+             nzt_pavement = pavement_depth_level
+          ENDIF
+
+       ENDIF
+!
+!--    Level 1 initialization of pavement type surfaces. Horizontally 
+!--    homogeneous characteristics are assumed
+       surf_lsm_h%nzt_pavement = pavement_depth_level
+       DO  m = 1, surf_lsm_h%ns
+          IF ( surf_lsm_h%pavement_surface(m) )  THEN
+             surf_lsm_h%nzt_pavement(m)        = nzt_pavement
+             surf_lsm_h%z0(m)                  = z0_pavement
+             surf_lsm_h%z0h(m)                 = z0h_pavement
+             surf_lsm_h%z0q(m)                 = z0h_pavement
+             surf_lsm_h%lambda_surface_s(m)    = pavement_heat_conduct         &
+                                                  * ddz_soil(nzb_soil)         &
+                                                  * 2.0_wp    
+             surf_lsm_h%lambda_surface_u(m)    = pavement_heat_conduct         &
+                                                  * ddz_soil(nzb_soil)         &
+                                                  * 2.0_wp           
+             surf_lsm_h%c_surface(m)           = pavement_heat_capacity        &
+                                                        * dz_soil(nzb_soil)    &
+                                                        * 0.25_wp                                   
+
+             surf_lsm_h%albedo_type(ind_pav,m) = albedo_type
+             surf_lsm_h%emissivity(ind_pav,m)  = emissivity      
+      
+             IF ( pavement_type /= 0 )  THEN
+                DO  k = nzb_soil, surf_lsm_h%nzt_pavement(m)
+                   surf_lsm_h%lambda_h_def(k,m)    =                           &
+                                     pavement_subsurface_pars_1(k,pavement_type)                       
+                   surf_lsm_h%rho_c_total_def(k,m) =                           &
+                                     pavement_subsurface_pars_2(k,pavement_type) 
+                ENDDO
+             ELSE
+                surf_lsm_v(l)%lambda_h_def(:,m)     = pavement_heat_conduct
+                surf_lsm_v(l)%rho_c_total_def(:,m)  = pavement_heat_capacity
+             ENDIF        
+          ENDIF
+       ENDDO                               
+
+       DO  l = 0, 3
+          surf_lsm_v(l)%nzt_pavement = pavement_depth_level
+          DO  m = 1, surf_lsm_v(l)%ns
+             IF ( surf_lsm_v(l)%pavement_surface(m) )  THEN
+                surf_lsm_v(l)%nzt_pavement(m)        = nzt_pavement
+                surf_lsm_v(l)%z0(m)                  = z0_pavement
+                surf_lsm_v(l)%z0h(m)                 = z0h_pavement
+                surf_lsm_v(l)%z0q(m)                 = z0h_pavement
+                surf_lsm_v(l)%lambda_surface_s(m)    = pavement_heat_conduct   &
+                                                  * ddz_soil(nzb_soil)         &
+                                                  * 2.0_wp    
+                surf_lsm_v(l)%lambda_surface_u(m)    = pavement_heat_conduct   &
+                                                  * ddz_soil(nzb_soil)         &
+                                                  * 2.0_wp           
+                surf_lsm_v(l)%c_surface(m)           = pavement_heat_capacity  &
+                                                        * dz_soil(nzb_soil)    &
+                                                        * 0.25_wp                                      
+
+                surf_lsm_v(l)%albedo_type(ind_pav,m) = albedo_type
+                surf_lsm_v(l)%emissivity(ind_pav,m)  = emissivity
+
+                IF ( pavement_type /= 0 )  THEN
+                   DO  k = nzb_soil, surf_lsm_v(l)%nzt_pavement(m)
+                      surf_lsm_v(l)%lambda_h_def(k,m)    =                     &
+                                     pavement_subsurface_pars_1(k,pavement_type)                       
+                      surf_lsm_v(l)%rho_c_total_def(k,m) =                     &
+                                     pavement_subsurface_pars_2(k,pavement_type) 
+                   ENDDO
+                ELSE
+                   surf_lsm_v(l)%lambda_h_def(:,m)     = pavement_heat_conduct
+                   surf_lsm_v(l)%rho_c_total_def(:,m)  = pavement_heat_capacity
+                ENDIF     
+             ENDIF
+          ENDDO
+       ENDDO
+!
+!--    Level 2 initialization of pavement type surfaces via pavement_type read
+!--    from file. Pavement surfaces are initialized for each (y,x)-grid point 
+!--    individually.
+       IF ( pavement_type_f%from_file )  THEN
+!
+!--       Horizontal surfaces
+          DO  m = 1, surf_lsm_h%ns
+             i = surf_lsm_h%i(m)
+             j = surf_lsm_h%j(m)
+             
+             st = pavement_type_f%var(j,i)
+             IF ( st /= pavement_type_f%fill  .AND.  st /= 0 )  THEN
+!
+!--             Determine deepmost index of pavement layer
+                DO  k = nzb_soil, nzt_soil  
+                   IF ( pavement_subsurface_pars_1(k,st) == 9999999.9_wp       &
+                   .OR. pavement_subsurface_pars_2(k,st) == 9999999.9_wp)      &
+                   THEN
+                      surf_lsm_h%nzt_pavement(m) = k-1
+                      EXIT
+                   ENDIF
+                ENDDO
+
+                surf_lsm_h%z0(m)                = pavement_pars(ind_p_z0,st)
+                surf_lsm_h%z0h(m)               = pavement_pars(ind_p_z0h,st)
+                surf_lsm_h%z0q(m)               = pavement_pars(ind_p_z0h,st)
+
+                surf_lsm_h%lambda_surface_s(m)  =                              &
+                                              pavement_subsurface_pars_1(0,st) &
+                                                  * ddz_soil(nzb_soil)         &
+                                                  * 2.0_wp    
+                surf_lsm_h%lambda_surface_u(m)  =                              &
+                                              pavement_subsurface_pars_1(0,st) &
+                                                  * ddz_soil(nzb_soil)         &
+                                                  * 2.0_wp        
+                surf_lsm_h%c_surface(m)         =                              &
+                                               pavement_subsurface_pars_2(0,st)&
+                                                        * dz_soil(nzb_soil)    &
+                                                        * 0.25_wp                               
+                surf_lsm_h%albedo_type(ind_pav,m) = INT( pavement_pars(ind_p_at,st) )
+                surf_lsm_h%emissivity(ind_pav,m)  = pavement_pars(ind_p_emis,st)  
+
+                DO  k = nzb_soil, surf_lsm_h%nzt_pavement(m)
+                   surf_lsm_h%lambda_h_def(k,m)    =                           &
+                                     pavement_subsurface_pars_1(k,pavement_type)                       
+                   surf_lsm_h%rho_c_total_def(k,m) =                           &
+                                     pavement_subsurface_pars_2(k,pavement_type) 
+                ENDDO   
+             ENDIF
+          ENDDO
+!
+!--       Vertical surfaces
+          DO  l = 0, 3
+             DO  m = 1, surf_lsm_v(l)%ns
+                i = surf_lsm_v(l)%i(m) + MERGE( 0, surf_lsm_v(l)%ioff,         &
+                                                surf_lsm_v(l)%building_covered(m) ) 
+                j = surf_lsm_v(l)%j(m) + MERGE( 0, surf_lsm_v(l)%joff,         &
+                                                surf_lsm_v(l)%building_covered(m) ) 
+             
+                st = pavement_type_f%var(j,i)
+                IF ( st /= pavement_type_f%fill  .AND.  st /= 0 )  THEN
+!
+!--                Determine deepmost index of pavement layer
+                   DO  k = nzb_soil, nzt_soil  
+                      IF ( pavement_subsurface_pars_1(k,st) == 9999999.9_wp    &
+                      .OR. pavement_subsurface_pars_2(k,st) == 9999999.9_wp)   &
+                      THEN
+                         surf_lsm_v(l)%nzt_pavement(m) = k-1
+                         EXIT
+                      ENDIF
+                   ENDDO
+
+                   surf_lsm_v(l)%z0(m)  = pavement_pars(ind_p_z0,st)
+                   surf_lsm_v(l)%z0h(m) = pavement_pars(ind_p_z0h,st)
+                   surf_lsm_v(l)%z0q(m) = pavement_pars(ind_p_z0h,st)
+
+                   surf_lsm_v(l)%lambda_surface_s(m)  =                        &
+                                              pavement_subsurface_pars_1(0,st) &
+                                                  * ddz_soil(nzb_soil)         & 
+                                                  * 2.0_wp    
+                   surf_lsm_v(l)%lambda_surface_u(m)  =                        &
+                                              pavement_subsurface_pars_1(0,st) &
+                                                  * ddz_soil(nzb_soil)         &
+                                                  * 2.0_wp     
+
+                   surf_lsm_v(l)%c_surface(m)    =                             &
+                                           pavement_subsurface_pars_2(0,st)    &
+                                                        * dz_soil(nzb_soil)    &
+                                                        * 0.25_wp                                    
+                   surf_lsm_v(l)%albedo_type(ind_pav,m) =                      &
+                                              INT( pavement_pars(ind_p_at,st) )
+                   surf_lsm_v(l)%emissivity(ind_pav,m)  =                      &
+                                              pavement_pars(ind_p_emis,st)    
+
+                   DO  k = nzb_soil, surf_lsm_h%nzt_pavement(m)
+                      surf_lsm_v(l)%lambda_h_def(k,m)    =                    &
+                                    pavement_subsurface_pars_1(k,pavement_type)                       
+                      surf_lsm_v(l)%rho_c_total_def(k,m) =                    &
+                                    pavement_subsurface_pars_2(k,pavement_type) 
+                   ENDDO   
+                ENDIF
+             ENDDO
+          ENDDO
+       ENDIF 
+!
+!--    Level 3, initialization of pavement parameters at single (x,y) 
+!--    position via pavement_pars read from file.
+       IF ( pavement_pars_f%from_file )  THEN
+!
+!--       Horizontal surfaces 
+          DO  m = 1, surf_lsm_h%ns
+             i = surf_lsm_h%i(m)
+             j = surf_lsm_h%j(m)
+!
+!--          If surface element is not a pavement surface and any value in 
+!--          pavement_pars is given, neglect this information and give an
+!--          informative message that this value will not be used.   
+             IF ( .NOT. surf_lsm_h%pavement_surface(m)  .AND.                  &
+                   ANY( pavement_pars_f%pars_xy(:,j,i) /=                      &
+                   pavement_pars_f%fill ) )  THEN
+                WRITE( message_string, * )                                     &
+                              'surface element at grid point (j,i) = (',       &
+                              j, i, ') is not a pavement surface, ',           &
+                              'so that information given in ',                 &
+                              'pavement_pars at this point is neglected.' 
+                CALL message( 'land_surface_model_mod', 'PA0999', 0, 0, 0, 6, 0 )
+             ELSE
+                IF ( pavement_pars_f%pars_xy(ind_p_z0,j,i) /=                  &
+                     pavement_pars_f%fill )                                    &
+                   surf_lsm_h%z0(m)  = pavement_pars_f%pars_xy(ind_p_z0,j,i)
+                IF ( pavement_pars_f%pars_xy(ind_p_z0h,j,i) /=                 &
+                     pavement_pars_f%fill )  THEN
+                   surf_lsm_h%z0h(m) = pavement_pars_f%pars_xy(ind_p_z0h,j,i)
+                   surf_lsm_h%z0q(m) = pavement_pars_f%pars_xy(ind_p_z0h,j,i)
+                ENDIF
+                IF ( pavement_subsurface_pars_f%pars_xyz(ind_p_lambda_h,0,j,i) &
+                     /= pavement_subsurface_pars_f%fill )  THEN
+                   surf_lsm_h%lambda_surface_s(m)  =                           &
+                      pavement_subsurface_pars_f%pars_xyz(ind_p_lambda_h,0,j,i)&
+                                                  * ddz_soil(nzb_soil)         &
+                                                  * 2.0_wp
+                   surf_lsm_h%lambda_surface_u(m)  =                           &
+                      pavement_subsurface_pars_f%pars_xyz(ind_p_lambda_h,0,j,i)&
+                                                  * ddz_soil(nzb_soil)         &
+                                                  * 2.0_wp    
+                ENDIF
+                IF ( pavement_subsurface_pars_f%pars_xyz(ind_p_rho_c,0,j,i) /= &
+                     pavement_subsurface_pars_f%fill )  THEN
+                   surf_lsm_h%c_surface(m)     =                               &
+                      pavement_subsurface_pars_f%pars_xyz(ind_p_rho_c,0,j,i)   &
+                                                  * dz_soil(nzb_soil)          &
+                                                  * 0.25_wp                                    
+                ENDIF
+                IF ( pavement_pars_f%pars_xy(ind_p_at,j,i) /=                  &
+                     pavement_pars_f%fill )                                    &
+                   surf_lsm_h%albedo_type(ind_pav,m) =                         &
+                                              INT( pavement_pars(ind_p_at,st) )
+                IF ( pavement_pars_f%pars_xy(ind_p_emis,j,i) /=                &
+                     pavement_pars_f%fill )                                    &
+                   surf_lsm_h%emissivity(ind_pav,m)  =                         &
+                                              pavement_pars(ind_p_emis,st) 
+             ENDIF 
+
+          ENDDO
+!
+!--       Vertical surfaces 
+          DO  l = 0, 3
+             DO  m = 1, surf_lsm_v(l)%ns
+                i = surf_lsm_v(l)%i(m) + MERGE( 0, surf_lsm_v(l)%ioff,         &
+                                                surf_lsm_v(l)%building_covered(m) ) 
+                j = surf_lsm_v(l)%j(m) + MERGE( 0, surf_lsm_v(l)%joff,         &
+                                                surf_lsm_v(l)%building_covered(m) ) 
+!
+!--             If surface element is not a pavement surface and any value in 
+!--             pavement_pars is given, neglect this information and give an
+!--             informative message that this value will not be used.   
+                IF ( .NOT. surf_lsm_v(l)%pavement_surface(m)  .AND.            &
+                      ANY( pavement_pars_f%pars_xy(:,j,i) /=                   &
+                      pavement_pars_f%fill ) )  THEN
+                   WRITE( message_string, * )                                  &
+                                 'surface element at grid point (j,i) = (',    &
+                                 j, i, ') is not a pavement surface, ',        &
+                                 'so that information given in ',              &
+                                 'pavement_pars at this point is neglected.' 
+                   CALL message( 'land_surface_model_mod', 'PA0999', 0, 0, 0, 6, 0 )
+                ELSE
+
+                   IF ( pavement_pars_f%pars_xy(ind_p_z0,j,i) /=               &
+                        pavement_pars_f%fill )                                 &
+                      surf_lsm_v(l)%z0(m) = pavement_pars_f%pars_xy(ind_p_z0,j,i)
+                   IF ( pavement_pars_f%pars_xy(ind_p_z0h,j,i) /=              &
+                        pavement_pars_f%fill )  THEN
+                      surf_lsm_v(l)%z0h(m) = pavement_pars_f%pars_xy(ind_p_z0h,j,i)
+                      surf_lsm_v(l)%z0q(m) = pavement_pars_f%pars_xy(ind_p_z0h,j,i)
+                   ENDIF
+                   IF ( pavement_subsurface_pars_f%pars_xyz(ind_p_lambda_h,0,j,i)&
+                        /= pavement_subsurface_pars_f%fill )  THEN
+                      surf_lsm_v(l)%lambda_surface_s(m) =                      &
+                      pavement_subsurface_pars_f%pars_xyz(ind_p_lambda_h,0,j,i)&
+                                                  * ddz_soil(nzb_soil)         &
+                                                  * 2.0_wp
+                      surf_lsm_v(l)%lambda_surface_u(m) =                      &
+                      pavement_subsurface_pars_f%pars_xyz(ind_p_lambda_h,0,j,i)&
+                                                  * ddz_soil(nzb_soil)         &
+                                                  * 2.0_wp    
+                   ENDIF
+                   IF ( pavement_subsurface_pars_f%pars_xyz(ind_p_rho_c,0,j,i) &
+                        /= pavement_subsurface_pars_f%fill )  THEN
+                      surf_lsm_v(l)%c_surface(m)    =                          &
+                         pavement_subsurface_pars_f%pars_xyz(ind_p_rho_c,0,j,i)&
+                                                  * dz_soil(nzb_soil)          &
+                                                  * 0.25_wp                                  
+                   ENDIF
+                   IF ( pavement_pars_f%pars_xy(ind_p_at,j,i) /=               &
+                        pavement_pars_f%fill )                                 &
+                      surf_lsm_v(l)%albedo_type(ind_pav,m) =                   &
+                                            INT( pavement_pars(ind_p_at,st) )
+
+                   IF ( pavement_pars_f%pars_xy(ind_p_emis,j,i) /=             &
+                        pavement_pars_f%fill )                                 &
+                      surf_lsm_v(l)%emissivity(ind_pav,m)  =                   &
+                                            pavement_pars(ind_p_emis,st)  
+                ENDIF 
+             ENDDO
+          ENDDO
+       ENDIF
+!
+!--    Moreover, for grid points which are flagged with pavement-type 0 or whre 
+!--    pavement_subsurface_pars_f is provided, soil heat conductivity and 
+!--    capacity are initialized with parameters given in        
+!--    pavement_subsurface_pars read from file. 
+       IF ( pavement_subsurface_pars_f%from_file )  THEN
+!
+!--       Set pavement depth to nzt_soil. Please note, this is just a 
+!--       workaround at the moment. 
+          DO  m = 1, surf_lsm_h%ns
+             IF ( surf_lsm_h%pavement_surface(m) )  THEN
+
+                i = surf_lsm_h%i(m)
+                j = surf_lsm_h%j(m)
+
+                surf_lsm_h%nzt_pavement(m) = nzt_soil
+
+                DO  k = nzb_soil, nzt_soil  
+                   surf_lsm_h%lambda_h_def(k,m) =                              &
+                       pavement_subsurface_pars_f%pars_xyz(ind_p_lambda_h,k,j,i)
+                   surf_lsm_h%rho_c_total_def(k,m) =                           &
+                       pavement_subsurface_pars_f%pars_xyz(ind_p_rho_c,k,j,i)
+                ENDDO
+
+             ENDIF
+          ENDDO
+          DO  l = 0, 3
+             DO  m = 1, surf_lsm_v(l)%ns
+                IF ( surf_lsm_v(l)%pavement_surface(m) )  THEN
+
+                   i = surf_lsm_v(l)%i(m) + MERGE( 0, surf_lsm_v(l)%ioff,      &
+                                                surf_lsm_v(l)%building_covered(m) ) 
+                   j = surf_lsm_v(l)%j(m) + MERGE( 0, surf_lsm_v(l)%joff,      &
+                                                surf_lsm_v(l)%building_covered(m) ) 
+
+                   surf_lsm_v(l)%nzt_pavement(m) = nzt_soil
+
+                   DO  k = nzb_soil, nzt_soil  
+                      surf_lsm_v(l)%lambda_h_def(k,m) =                        &
+                       pavement_subsurface_pars_f%pars_xyz(ind_p_lambda_h,k,j,i)
+                      surf_lsm_v(l)%rho_c_total_def(k,m) =                     &
+                       pavement_subsurface_pars_f%pars_xyz(ind_p_rho_c,k,j,i)
+                   ENDDO
+
+                ENDIF
+             ENDDO
+          ENDDO
+       ENDIF
 !
 !--    Initial run actions
        IF (  TRIM( initializing_actions ) /= 'read_restart_data' )  THEN
 !
-!--       First, for horizontal surfaces
-!
-!--       Set artifical values for ts and us so that r_a has its initial value 
-!--       for the first time step. Only for interior core domain, not for ghost points
+!--       First, initialize soil temperature and moisture. 
+!--       According to the initialization for surface and soil parameters, 
+!--       initialize soil moisture and temperature via a level approach. This 
+!--       is to assure that all surface elements are initialized, even if 
+!--       data provided from input file contains fill values at some locations.
+!--       Level 1, initialization via profiles given in parameter file
           DO  m = 1, surf_lsm_h%ns
-
-             t_soil_h%var_2d(:,m)    = 0.0_wp
-             m_soil_h%var_2d(:,m)    = 0.0_wp
-             m_liq_h%var_1d(m)       = 0.0_wp
-
-!--          Map user settings of T and q for each soil layer
-!--          (make sure that the soil moisture does not drop below the permanent
-!--          wilting point) -> problems with devision by zero)
-             IF ( surf_lsm_h%water_surface(m) )  THEN
-
-                surf_lsm_h%z0(m)          = z0_water
-                surf_lsm_h%z0h(m)         = z0h_water
-                surf_lsm_h%z0q(m)         = z0h_water
-                t_soil_h%var_2d(:,m)      = water_temperature
-                surf_lsm_h%lambda_surface_s(m) = 1.0E10_wp
-                surf_lsm_h%lambda_surface_u(m) = 1.0E10_wp               
-                surf_lsm_h%c_surface(m)        = 0.0_wp
-                
-             ELSEIF ( surf_lsm_h%pavement_surface(m) )  THEN
-
-                surf_lsm_h%z0(m)          = z0_pavement
-                surf_lsm_h%z0h(m)         = z0h_pavement
-                surf_lsm_h%z0q(m)         = z0h_pavement   
+             IF ( surf_lsm_h%vegetation_surface(m)  .OR.                       &
+                  surf_lsm_h%pavement_surface(m) )  THEN
                 DO  k = nzb_soil, nzt_soil  
-                   t_soil_h%var_2d(k,m)   = soil_temperature(k)
-                   m_soil_h%var_2d(k,m)   = soil_moisture(k)
+                   t_soil_h%var_2d(k,m) = soil_temperature(k)
+                   m_soil_h%var_2d(k,m) = soil_moisture(k)
                 ENDDO
                 t_soil_h%var_2d(nzt_soil+1,m) = soil_temperature(nzt_soil+1)
-                surf_lsm_h%lambda_surface_s(m) = pavement_heat_conduct         &
-                                                 * ddz_soil(nzb_soil)          &
-                                                 * 2.0_wp
-                surf_lsm_h%lambda_surface_u(m) = surf_lsm_h%lambda_surface_s(m)                                         
-                surf_lsm_h%c_surface(m)        = pavement_heat_capacity        &
-                                                 * dz_soil(nzb_soil)           &
-                                                 * 0.25_wp
-
-                IF ( pavement_type /= 0 )  THEN
+             ENDIF
+          ENDDO
+          DO  l = 0, 3
+             DO  m = 1, surf_lsm_v(l)%ns
+                IF ( surf_lsm_v(l)%vegetation_surface(m)  .OR.                 &
+                     surf_lsm_v(l)%pavement_surface(m) )  THEN
                    DO  k = nzb_soil, nzt_soil  
-                      surf_lsm_h%lambda_h_def(k,m)      =  pavement_subsurface_pars_1(k,pavement_type)                       
-                      surf_lsm_h%rho_c_total_def(k,m)   =  pavement_subsurface_pars_2(k,pavement_type) 
+                      t_soil_v(l)%var_2d(k,m) = soil_temperature(k)
+                      m_soil_v(l)%var_2d(k,m) = soil_moisture(k)
                    ENDDO
-                ELSE
-                    surf_lsm_h%lambda_h_def(:,m)     = pavement_heat_conduct
-                    surf_lsm_h%rho_c_total_def(:,m)  = pavement_heat_capacity
+                   t_soil_v(l)%var_2d(nzt_soil+1,m) = soil_temperature(nzt_soil+1)
                 ENDIF
-
-             ELSEIF ( surf_lsm_h%vegetation_surface(m) )  THEN
-
-                surf_lsm_h%z0(m)          = z0_vegetation
-                surf_lsm_h%z0h(m)         = z0h_vegetation
-                surf_lsm_h%z0q(m)         = z0h_vegetation   
-                DO  k = nzb_soil, nzt_soil                        
-                   t_soil_h%var_2d(k,m)   = soil_temperature(k)
-                   m_soil_h%var_2d(k,m)   = soil_moisture(k)       
-                ENDDO 
-                t_soil_h%var_2d(nzt_soil+1,m) = soil_temperature(nzt_soil+1)
-                surf_lsm_h%lambda_surface_s(m) = lambda_surface_stable
-                surf_lsm_h%lambda_surface_u(m) = lambda_surface_unstable
-                surf_lsm_h%c_surface(m)        = c_surface
-
+             ENDDO
+          ENDDO
+!
+!--       Level 2, if soil moisture and/or temperature  are 
+!--       provided from file, interpolate / extrapolate the provided data
+!--       onto the respective soil layers. Please note, both, zs as well as 
+!--       init_3d%z_soil indicate a depth with positive values, so that no 
+!--       distinction between atmosphere is required concerning interpolation.
+!--       Start with soil moisture
+          IF ( init_3d%from_file_msoil )  THEN
+
+             IF ( init_3d%lod_msoil == 1 )  THEN
+                DO  m = 1, surf_lsm_h%ns
+
+                   CALL netcdf_data_input_interpolate(                         &
+                                       m_soil_h%var_2d(nzb_soil:nzt_soil,m),   &
+                                       init_3d%msoil_init(:),                  &
+                                       zs(nzb_soil:nzt_soil), init_3d%z_soil,  &
+                                       nzb_soil, nzt_soil,                     &
+                                       nzb_soil, init_3d%nzs-1 )
+                ENDDO
+                DO  l = 0, 3
+                   DO  m = 1, surf_lsm_v(l)%ns
+
+                      CALL netcdf_data_input_interpolate(                      &
+                                       m_soil_v(l)%var_2d(nzb_soil:nzt_soil,m),&
+                                       init_3d%msoil_init(:),                  &
+                                       zs(nzb_soil:nzt_soil), init_3d%z_soil,  &
+                                       nzb_soil, nzt_soil,                     &
+                                       nzb_soil, init_3d%nzs-1 )
+                   ENDDO
+                ENDDO
+             ELSE
+
+                DO  m = 1, surf_lsm_h%ns
+                   i = surf_lsm_h%i(m)
+                   j = surf_lsm_h%j(m)
+
+                   IF ( init_3d%msoil(0,j,i) /= init_3d%fill_msoil )           &
+                      CALL netcdf_data_input_interpolate(                      &
+                                       m_soil_h%var_2d(nzb_soil:nzt_soil,m),   &
+                                       init_3d%msoil(:,j,i),                   &
+                                       zs(nzb_soil:nzt_soil), init_3d%z_soil,  &
+                                       nzb_soil, nzt_soil,                     &
+                                       nzb_soil, init_3d%nzs-1 )
+                ENDDO
+                DO  l = 0, 3
+                   DO  m = 1, surf_lsm_v(l)%ns
+                      i = surf_lsm_v(l)%i(m) + MERGE( 0, surf_lsm_v(l)%ioff,   &
+                                             surf_lsm_v(l)%building_covered(m) ) 
+                      j = surf_lsm_v(l)%j(m) + MERGE( 0, surf_lsm_v(l)%joff,   &
+                                             surf_lsm_v(l)%building_covered(m) ) 
+
+                      IF ( init_3d%msoil(0,j,i) /= init_3d%fill_msoil )        &
+                         CALL netcdf_data_input_interpolate(                   &
+                                       m_soil_v(l)%var_2d(nzb_soil:nzt_soil,m),&
+                                       init_3d%msoil(:,j,i),                   &
+                                       zs(nzb_soil:nzt_soil), init_3d%z_soil,  &
+                                       nzb_soil, nzt_soil,                     &
+                                       nzb_soil, init_3d%nzs-1 )
+                   ENDDO
+                ENDDO
              ENDIF
- 
+
+          ENDIF
+!
+!--       Soil temperature
+          IF ( init_3d%from_file_tsoil )  THEN
+
+             IF ( init_3d%lod_tsoil == 1 )  THEN ! change to 1 if provided correctly by INIFOR
+                DO  m = 1, surf_lsm_h%ns
+
+                   CALL netcdf_data_input_interpolate(                         &
+                                       t_soil_h%var_2d(nzb_soil:nzt_soil,m),   &
+                                       init_3d%tsoil_init(:),                  &
+                                       zs(nzb_soil:nzt_soil), init_3d%z_soil,  &
+                                       nzb_soil, nzt_soil,                     &
+                                       nzb_soil, init_3d%nzs-1 )
+                   t_soil_h%var_2d(nzt_soil+1,m) = t_soil_h%var_2d(nzt_soil,m)
+                ENDDO
+                DO  l = 0, 3
+                   DO  m = 1, surf_lsm_v(l)%ns
+
+                      CALL netcdf_data_input_interpolate(                      &
+                                       t_soil_v(l)%var_2d(nzb_soil:nzt_soil,m),&
+                                       init_3d%tsoil_init(:),                  &
+                                       zs(nzb_soil:nzt_soil), init_3d%z_soil,  &
+                                       nzb_soil, nzt_soil,                     &
+                                       nzb_soil, init_3d%nzs-1 )
+                      t_soil_v(l)%var_2d(nzt_soil+1,m) =                       &
+                                                 t_soil_v(l)%var_2d(nzt_soil,m)
+                   ENDDO
+                ENDDO
+             ELSE
+
+                DO  m = 1, surf_lsm_h%ns
+                   i = surf_lsm_h%i(m)
+                   j = surf_lsm_h%j(m)
+
+                   IF ( init_3d%msoil(0,j,i) /= init_3d%fill_msoil )           &
+                      CALL netcdf_data_input_interpolate(                      &
+                                       t_soil_h%var_2d(nzb_soil:nzt_soil,m),   &
+                                       init_3d%tsoil(:,j,i),                   &
+                                       zs(nzb_soil:nzt_soil), init_3d%z_soil,  &
+                                       nzb_soil, nzt_soil,                     &
+                                       nzb_soil, init_3d%nzs-1 )
+                   t_soil_h%var_2d(nzt_soil+1,m) = t_soil_h%var_2d(nzt_soil,m)
+                ENDDO
+                DO  l = 0, 3
+                   DO  m = 1, surf_lsm_v(l)%ns
+                      i = surf_lsm_v(l)%i(m) + MERGE( 0, surf_lsm_v(l)%ioff,   &
+                                                surf_lsm_v(l)%building_covered(m) ) 
+                      j = surf_lsm_v(l)%j(m) + MERGE( 0, surf_lsm_v(l)%joff,   &
+                                                surf_lsm_v(l)%building_covered(m) ) 
+
+                      IF ( init_3d%msoil(0,j,i) /= init_3d%fill_msoil )        &
+                         CALL netcdf_data_input_interpolate(                   &
+                                       t_soil_v(l)%var_2d(nzb_soil:nzt_soil,m),&
+                                       init_3d%tsoil(:,j,i),                   &
+                                       zs(nzb_soil:nzt_soil), init_3d%z_soil,  &
+                                       nzb_soil, nzt_soil,                     &
+                                       nzb_soil, init_3d%nzs-1 )
+                      t_soil_v(l)%var_2d(nzt_soil+1,m) =                       &
+                                                 t_soil_v(l)%var_2d(nzt_soil,m)
+                   ENDDO
+                ENDDO
+             ENDIF
+          ENDIF
+!
+!--       Further initialization
+          DO  m = 1, surf_lsm_h%ns
+
              i   = surf_lsm_h%i(m)            
              j   = surf_lsm_h%j(m)
